unit main;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, ComCtrls, ExtCtrls,
	Menus,
	ImgList,
	ToolWin,
	DirectShow9;

const
	//Cxg󂯎邽߂̃j[NȃbZ[Wԍ
	WM_GRAPH_NOTIFY = (WM_APP +1);

type
	TForm1 = class(TForm)
		MainMenu1:           TMainMenu;
		MenuItem_File:       TMenuItem;
		MenuItem_FileOpen:   TMenuItem;
		MenuItem_FileLine1:  TMenuItem;
    MenuItem_ListDelete: TMenuItem;
		MenuItem_ListClear:  TMenuItem;
		MenuItem_FileLine2:  TMenuItem;
		MenuItem_FileExit:   TMenuItem;
		MenuItem_Play:       TMenuItem;
		MenuItem_PlayPause:  TMenuItem;
		MenuItem_PlayStop:   TMenuItem;
		MenuItem_PlayLine1:  TMenuItem;
		MenuItem_PlayBack:   TMenuItem;
		MenuItem_PlayNext:   TMenuItem;
		MenuItem_Video:      TMenuItem;
    MenuItem_KeepAspect: TMenuItem;
		MenuItem_VideoLine1: TMenuItem;
		MenuItem_Capture:    TMenuItem;
		MenuItem_Opt:        TMenuItem;
		MenuItem_Event:      TMenuItem;
		ComboBox1:         TComboBox;
		TrackBar1:         TTrackBar;
		Timer1:            TTimer;
		OpenDialog1:       TOpenDialog;
		Panel_Video:       TPanel;
		Panel_Control:     TPanel;
		ToolBar1:          TToolBar;
		Button_PlayPause:  TToolButton;
		Button_Stop:       TToolButton;
		Button_PlayBack:   TToolButton;
		Button_PlayNext:   TToolButton;
		Button_Spc1:       TToolButton;
		Button_Capture:    TToolButton;
		Button_KeepAspect: TToolButton;
		Button_Spc2:       TToolButton;
		Label_Size:        TLabel;
		Label_Time:        TLabel;
		ImageList1:        TImageList;

		procedure FormCreate (Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure MenuItem_FileExitClick  (Sender: TObject);
		procedure Button_OpenClick        (Sender: TObject);
		procedure Button_DeleteClick      (Sender: TObject);
		procedure Button_ClearClick       (Sender: TObject);
		procedure Button_PlayPauseClick   (Sender: TObject);
		procedure Button_PlayClick        (Sender: TObject);
		procedure Button_PauseClick       (Sender: TObject);
		procedure Button_StopClick        (Sender: TObject);
		procedure Button_PlayBackClick    (Sender: TObject);
		procedure Button_PlayNextClick    (Sender: TObject);
		procedure Button_CaptureClick     (Sender: TObject);
		procedure ComboBox1Select         (Sender: TObject);
		procedure TrackBar1Change         (Sender: TObject);
		procedure Timer1Timer             (Sender: TObject);
		procedure CheckBox_KeepAspectClick(Sender: TObject);
		procedure Panel_VideoResize       (Sender: TObject);
		procedure Panel_VideoDblClick     (Sender: TObject);
	private
		{ Private 錾 }
		F_GraphBuilder  : IGraphBuilder;
		F_MediaEventEx  : IMediaEventEx;
		F_MediaPosition : IMediaPosition;
		F_fDuration     : TRefTime;
		F_VideoRenderer : IBaseFilter;
		F_sFileName     : WideString;

		//Cxgʒm̂߂̃bZ[Wԍ󂯎悤ɂ
		procedure WMGraphNotify  (var Msg: TMessage); message WM_GRAPH_NOTIFY;
		//fBXvCݒ̕ύX
		procedure WMDisplayChange(var Msg: TMessage); message WM_DISPLAYCHANGE;
		procedure F_Close;
		function  F_GetFrameRate : String;
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation
uses
	ActiveX,
	BaseClass,
	CommCtrl,
	DSUtil,
	capt,      //Lv`p
	debug_msg; //fobOo͗p

{$R *.dfm}


procedure TForm1.WMDisplayChange(var Msg: TMessage);
//TScreenMonitorsvpeBfBXvC̕ύXɒǐȂs̉̂߁B
begin
	 Self.Monitor;
end;


//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
	Label_Size.Caption := '';
	Label_Time.Caption := '';

	//Ot쐬
	CoCreateInstance(
		CLSID_FilterGraph,
		nil,
		CLSCTX_INPROC_SERVER,
		IID_IGraphBuilder,
		F_GraphBuilder
	);

	//CxgʒmEBhEZbgB
	F_GraphBuilder.QueryInterface(IMediaEventEx, F_MediaEventEx);
	F_MediaEventEx.SetNotifyWindow(Self.Handle, WM_GRAPH_NOTIFY, 0);

	//Ԏ擾̂
	F_GraphBuilder.QueryInterface(IMediaPosition, F_MediaPosition);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
	F_Close;
	F_MediaPosition       := nil;
	F_MediaEventEx        := nil;
	F_VideoRenderer       := nil;
	F_GraphBuilder        := nil;
end;

procedure TForm1.MenuItem_FileExitClick(Sender: TObject);
begin
	Close;
end;

procedure TForm1.WMGraphNotify(var Msg: TMessage);
//Cxg
var
	li_EventCode   : Longint;
	li_Param1      : Longint;
	li_Param2      : Longint;
begin
	if (F_MediaEventEx = nil) then begin
Exit;
	end;

	// CxgSĎ擾
	while (Succeeded(F_MediaEventEx.GetEvent(li_EventCode, li_Param1, li_Param2, 0))) do begin
		if (MenuItem_Event.Checked) then begin
			debug_msg.ShowEvent(li_EventCode, li_Param1, li_Param2);
		end;

		try
			case (li_EventCode) of
				EC_COMPLETE
				:begin
					//ĐIɗ
					//AĐ
					if (ComboBox1.Items.Count = 0) then begin
						F_Close;
					end else begin
						if (ComboBox1.ItemIndex < ComboBox1.Items.Count -1) then begin
							ComboBox1.ItemIndex := ComboBox1.ItemIndex +1;
						end else begin
							ComboBox1.ItemIndex := 0;
						end;
						ComboBox1Select(nil);
					end;
				end;
			end;
		finally
			F_MediaEventEx.FreeEventParams(li_EventCode, li_Param1, li_Param2);
		end;
	end;
end;

procedure TForm1.Button_PlayPauseClick(Sender: TObject);
//Đ/ꎞ~
var
	l_MediaControl : IMediaControl;
	l_State        : TFilterState;
begin
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.GetState(0, l_State);
		l_MediaControl := nil;
		if (l_State = State_Running) then begin
			Button_PauseClick(nil);
		end else begin
			Button_PlayClick(nil);
		end;
	end;
end;

procedure TForm1.Button_PlayClick(Sender: TObject);
//ĐJn
var
	l_MediaControl : IMediaControl;
begin
	if (Assigned(F_GraphBuilder)) then begin
		if (Assigned(F_VideoRenderer)) then begin
			F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
			l_MediaControl.Run;
			l_MediaControl := nil;
			Timer1.Enabled := True;
		end else begin
			Button_OpenClick(nil);
		end;
	end;
end;

procedure TForm1.Button_PauseClick(Sender: TObject);
//ꎞ~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Pause;
		l_MediaControl := nil;
		Timer1Timer(nil);
	end;
end;

procedure TForm1.Button_StopClick(Sender: TObject);
//~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Stop;

		//~łPauseƕςȂ
		//擪ɖ߂ɂIMediaPositiong
		F_MediaPosition.put_CurrentPosition(0);

		//ړł݈͌ʒũt[`悳ȂB
		//݈ʒũt[`悳邽߂Pause邢StopWhenReadyĂԁB
		l_MediaControl.StopWhenReady;
		l_MediaControl := nil;

		Timer1.Tag := 1;
		TrackBar1.Position := 0;
		Timer1.Tag := 0;
	end;
end;

procedure TForm1.Button_PlayBackClick(Sender: TObject);
//O
var
	li_Index : Integer;
begin
	if (ComboBox1.Items.Count > 0) then begin
		li_Index := ComboBox1.ItemIndex -1;
		if (li_Index < 0) then begin
			li_Index := ComboBox1.Items.Count -1;
		end;
		ComboBox1.ItemIndex := li_Index;
		ComboBox1Select(nil);
	end;
end;

procedure TForm1.Button_PlayNextClick(Sender: TObject);
//
var
	li_Index : Integer;
begin
	if (ComboBox1.Items.Count > 0) then begin
		li_Index := ComboBox1.ItemIndex +1;
		if (li_Index >= ComboBox1.Items.Count) then begin
			li_Index := 0;
		end;
		ComboBox1.ItemIndex := li_Index;
		ComboBox1Select(nil);
	end;
end;

procedure TForm1.F_Close;
var
	l_MediaControl : IMediaControl;
	l_EnumFilters  : IEnumFilters;
	l_BaseFilter   : IBaseFilter;
begin
	Timer1.Enabled     := False;
	Label_Size.Caption := '';
	Label_Time.Caption := '';

	if (F_GraphBuilder <> nil) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Stop;
		l_MediaControl := nil;

		//Sotpł̓tB^͂܂ڑꂽ܂܂Ȃ̂ŃtB^񋓂č폜B
		//http://msdn.microsoft.com/ja-jp/library/cc973418.aspx
		F_GraphBuilder.EnumFilters(l_EnumFilters);
		while (l_EnumFilters.Next(1, l_BaseFilter, nil) = S_OK) do begin
			F_GraphBuilder.RemoveFilter(l_BaseFilter);
			l_BaseFilter := nil;
			l_EnumFilters.Reset;
		end;
		l_EnumFilters := nil;
	end;
end;

procedure TForm1.Button_OpenClick(Sender: TObject);
//J
var
	li_Count : Integer;
begin
	if (OpenDialog1.Execute) then begin
		li_Count := ComboBox1.Items.Count;
		ComboBox1.Items.AddStrings(OpenDialog1.Files);
		ComboBox1.ItemIndex := li_Count;
		ComboBox1Select(nil); //ĐJn
	end;
end;

procedure TForm1.Button_DeleteClick(Sender: TObject);
//XgĐ̃t@C폜
var
	li_Index : Integer;
begin
	li_Index := ComboBox1.ItemIndex;
	F_Close;
	ComboBox1.Items.Delete(li_Index);
	ComboBox1.ItemIndex := li_Index;
	ComboBox1Select(nil);
end;

procedure TForm1.Button_ClearClick(Sender: TObject);
//XgNA
begin
	ComboBox1.Items.Clear;
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
//t@CIĐ
var
	l_VideoWindow : IVideoWindow;
	l_BasicVideo  : IBasicVideo;
	li_Width      : Integer;
	li_Height     : Integer;
begin
	F_Close;

	if (ComboBox1.Items.Count = 0) then begin
		Exit;
	end;

	//rfI_[쐬 (VMR7)
	F_VideoRenderer := nil;
	CoCreateInstance(
		CLSID_VideoMixingRenderer,
		nil,
		CLSCTX_INPROC,
		IID_IBaseFilter,
		F_VideoRenderer
	);
	F_GraphBuilder.AddFilter(F_VideoRenderer, 'Video Renderer');

	if (ComboBox1.ItemIndex < 0) then begin
		ComboBox1.ItemIndex := 0;
	end;
	F_sFileName := ComboBox1.Items[ComboBox1.ItemIndex];
	//ǂݍ
	if not(Succeeded(F_GraphBuilder.RenderFile(POLESTR(F_sFileName), nil))) then begin
//Ver5 ---
		ShowMessage(F_sFileName + #13'͊J܂');
		Button_DeleteClick(nil);
		Exit;
//Ver5 ---
	end;

	//AXyNgێ
	//t@CǂݍłłȂfXNgbvtbVĂ܂B
	CheckBox_KeepAspectClick(nil);

	//plɃrfI\
	//t@CǂݍłłȂƕʃEBhEJĂ܂B
	F_GraphBuilder.QueryInterface(IVideoWindow, l_VideoWindow);
	l_VideoWindow.put_Owner(Panel_Video.Handle);
	l_VideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
	l_VideoWindow.put_MessageDrain(Panel_Video.Handle); //}EXbZ[WE悤ɂ
	l_VideoWindow.SetWindowForeground(OAFALSE);         //^XNo[tbV̂h
	l_VideoWindow := nil;
	//rfĨTCYplɍ킹B
	Panel_VideoResize(nil);

	//^Cgo[Ƀt@C\
	Caption := ExtractFileName(F_sFileName);

	//rfĨTCY擾
	F_GraphBuilder.QueryInterface(IBasicVideo, l_BasicVideo);
	//li_Widthli_Height͕̏K{B
	li_Width  := 0;
	li_Height := 0;
	l_BasicVideo.get_VideoWidth (li_Width);
	l_BasicVideo.get_VideoHeight(li_Height);
	l_BasicVideo := nil;
	//t[[g擾
	if (li_Width > 0) and (li_Height > 0) then begin
		Label_Size.Caption := Format('%dx%d %sfps', [li_Width, li_Height, F_GetFrameRate]);
	end else begin
		Label_Size.Caption := '';
	end;

	//擾
	F_fDuration := 0;
	F_MediaPosition.get_Duration(F_fDuration); //̌CurrentPositionςĂ܂Ƃ
	TrackBar1.Max := Trunc(F_fDuration);

	//擾CurrentPositionIɈړĂ܂Ƃ̂œɖ߂
	//F_MediaPosition.put_CurrentPosition(0);
	//Button_StopClick̒łĂ
	//ĐJn
	Button_StopClick(nil);
	Button_PlayClick(nil);
end;

procedure TForm1.Panel_VideoResize(Sender: TObject);
//rfĨTCYplɍ킹B
var
	l_VideoWindow : IVideoWindow;
begin
	if  (F_GraphBuilder  <> nil)
	and (F_VideoRenderer <> nil)
	then begin
		F_GraphBuilder.QueryInterface(IVideoWindow, l_VideoWindow);
{
		łƂ
		l_VideoWindow.put_Owner(Panel_Video.Handle);
		l_VideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
		l_VideoWindow.put_MessageDrain(OATRUE);
		l_VideoWindow.SetWindowForeground(OAFALSE);
}
		l_VideoWindow.SetWindowPosition(0, 0, Panel_Video.Width, Panel_Video.Height);
		l_VideoWindow := nil;
	end;
end;

procedure TForm1.Panel_VideoDblClick(Sender: TObject);
//tXN[[hB
//}`j^[ɑΉB
//̃EBhEGƉB
//ȂςƕʃEBhEŕ\Ă܂sB
var
	l_VideoWindow : IVideoWindow;
	lb_FullScreen : LongBool;
begin
	if  (F_GraphBuilder  <> nil)
	and (F_VideoRenderer <> nil)
	then begin
		F_GraphBuilder.QueryInterface(IVideoWindow, l_VideoWindow);
		l_VideoWindow.get_FullScreenMode(lb_FullScreen);
		l_VideoWindow.put_FullScreenMode(not(lb_FullScreen));
		l_VideoWindow := nil;
	end;
end;

procedure TForm1.CheckBox_KeepAspectClick(Sender: TObject);
//AXyNgێB
var
	l_VMRAspectRatioControl : IVMRAspectRatioControl;
begin
	if (Sender <> nil) then begin
		MenuItem_KeepAspect.Checked := not(MenuItem_KeepAspect.Checked);
		Button_KeepAspect.Down      := MenuItem_KeepAspect.Checked;
	end;

	if (F_VideoRenderer = nil) then begin
		Exit;
	end;

	F_VideoRenderer.QueryInterface(IVMRAspectRatioControl, l_VMRAspectRatioControl);
	if (l_VMRAspectRatioControl <> nil) then begin
		if (MenuItem_KeepAspect.Checked) then begin
			//AXyNgێB
			l_VMRAspectRatioControl.SetAspectRatioMode(VMR_ARMODE_LETTER_BOX);
		end else begin
			//AXyNgρB
			l_VMRAspectRatioControl.SetAspectRatioMode(VMR_ARMODE_NONE);
		end;
		l_VMRAspectRatioControl := nil;
	end;
end;

//V[No[ ---
procedure TForm1.Timer1Timer(Sender: TObject);
//݈ʒu\B
	function FloatToTime(fTime : TRefTime) : String;
	var
		li_Time, li_Hour, li_Min, li_Sec : Integer;
	begin
		li_Time := Trunc(fTime);
		li_Hour := li_Time div 60 div 60;
		li_Min  := li_Time div 60 mod 60;
		li_Sec  := li_Time mod 60;
		Result  := Format('%d:%.2d:%.2d.%.3d', [li_Hour, li_Min, li_Sec, Trunc(Frac(fTime) * 1000)]);
//		Result  := Format('%d:%.2d:%.2d', [li_Hour, li_Min, li_Sec]);
	end;
	function IsDragThumb: Boolean;
	//gbNo[̃XC_[GĂ邩B
	//ۂ̓gbNo[}EXLv`Ă邩B
	begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			Result := False;
			Exit;
		end;
		Result := (GetCapture = TrackBar1.Handle);
	end;
var
	lf_Pos : Double;
begin
	if (Assigned(F_GraphBuilder)) then begin
		Timer1.Tag := 1;

		F_MediaPosition.get_CurrentPosition(lf_Pos);
		Label_Time.Caption := Format('%s/%s', [FloatToTime(lf_Pos), FloatToTime(F_fDuration)]);

		if not(IsDragThumb) then begin
			//gbNo[̃XC_[GĂȂXC_[݈ʒuɈړB
			TrackBar1.Position := Trunc(lf_Pos);
		end;

		Timer1.Tag := 0;
	end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
//gbNo[ړB
var
	l_MediaPosition : IMediaPosition;
begin
	if (Timer1.Tag <> 0) then begin
		Exit;
	end;

	if (Assigned(F_GraphBuilder)) then begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			F_GraphBuilder.QueryInterface(IMediaPosition, l_MediaPosition);
			l_MediaPosition.put_CurrentPosition(TrackBar1.Position);
			l_MediaPosition := nil;
		end;
	end;
end;
//--------


//Ver5 ---
function _Round(fNum: Double): Integer;
//fNumľܓĕԂB
//DelphĩwvRs[B
begin
	if (fNum >= 0) then begin
		Result := Trunc(fNum + 0.5);
	end else begin
		Result := Trunc(fNum - 0.5);
	end;
end;

function TForm1.F_GetFrameRate : String;
var
	li_Time     : Int64;
	l_EnumPins  : IEnumPins;
	l_Pin       : IPin;
	l_PinInfo   : TPinInfo;
	l_MediaType : TAMMediaType;
begin
	Result := '-';

	if (F_VideoRenderer = nil) then begin
		Exit;
	end;

	F_VideoRenderer.EnumPins(l_EnumPins);
	try
		while(l_EnumPins.Next(1, l_Pin, nil) = S_OK) do begin
			l_Pin.QueryPinInfo(l_PinInfo);
			try
				if (l_PinInfo.dir = PINDIR_INPUT) then begin
					//
					l_Pin.ConnectionMediaType(l_MediaType);
					try
						if (IsEqualGUID(l_MediaType.majortype,  MEDIATYPE_Video)) then begin
							if (IsEqualGUID(l_MediaType.formattype, FORMAT_VideoInfo)) then begin
								//VIDEOINFOHEADER
								li_Time := PVideoInfoHeader(l_MediaType.pbFormat)^.AvgTimePerFrame;
							end else if (IsEqualGUID(l_MediaType.formattype, FORMAT_VideoInfo2)) then begin
								//VIDEOINFOHEADER2
								li_Time := PVideoInfoHeader2(l_MediaType.pbFormat)^.AvgTimePerFrame;
							end else if (IsEqualGUID(l_MediaType.formattype, FORMAT_MPEGVideo)) then begin
								//MPEG1VIDEOINFO
								li_Time := PMpeg1VideoInfo(l_MediaType.pbFormat)^.hdr.AvgTimePerFrame;
							end else if (IsEqualGUID(l_MediaType.formattype, FORMAT_MPEG2Video)) then begin
								//MPEG2VIDEOINFO
								li_Time := PMpeg2VideoInfo(l_MediaType.pbFormat)^.hdr.AvgTimePerFrame;
							end else begin
								li_Time := 0;
							end;
							if (li_Time <> 0) then begin
								Result := Format('%g', [_Round(100 / (li_Time / UNITS)) / 100]);
							end;
							Break;
						end;
					finally
						FreeMediaType(@l_MediaType);
					end;
				end;
			finally
				if (l_PinInfo.pFilter <> nil) then begin
					l_PinInfo.pFilter := nil;
				end;
				l_Pin := nil;
			end;
		end;
	finally
		if (l_EnumPins <> nil) then begin
			l_EnumPins := nil;
		end;
	end;
end;

procedure TForm1.Button_CaptureClick(Sender: TObject);
//rfIfrbg}bv擾B
var
	lf_Pos : Double;
begin
	if (F_MediaPosition = nil) then begin
		Exit;
	end;

	//ݍĐ̃_[Ƃ͕ʂ̃_[iOtʁj擾B
	Button_Capture.Enabled := False;
	try
		F_MediaPosition.get_CurrentPosition(lf_Pos);
		if (capt.Capture(F_sFileName, lf_Pos)) then begin
			capt.CopyImage;
		end;
	finally
		Button_Capture.Enabled := True;
	end;
end;
//--------


end.
